#pragma once

#include "AbstractPainter.h"

#include <unordered_map>
#include <memory>

class DrawingContext;
class OpenGlFontTexture;
class OpenGlShaderProgram;

class TextData;
class TriMesh;

class OpenGlPainter : public AbstractPainter
{
public:
    OpenGlPainter();

    void paint(DrawingContext* context) override;

private:
    void initializeMeshShader();
    void initializeTextShader();

    void renderTextLayer(const TextData& textData, DrawingContext* context);
    void renderMeshLayer(TriMesh* mesh, DrawingContext* context);

    std::unique_ptr<OpenGlShaderProgram> mMeshShaderProgram;
    std::unique_ptr<OpenGlShaderProgram> mTextShaderProgram;
    std::unordered_map<char, std::unique_ptr<OpenGlFontTexture> > mFontTextures;
};


